Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# BillboardEffect Class Reference

Indicates that geometry at this node should automatically rotate to face the camera, or any other arbitrary node. More...

Inheritance diagram for BillboardEffect:

List of all members.

## Public Member Functions
bool | getAxialRotate ()
| Returns true if this billboard rotates only around the axis of the up vector, or false if it rotates freely in three dimensions.
bool | getEyeRelative ()
| Returns true if this billboard interprets the up vector relative to the camera, or false if it is relative to the world.
NodePath const | getLookAt ()
| Returns the node this billboard will rotate to look towards.
Point3 const | getLookAtPoint ()
| Returns the point, relative to the look_at node, towards which the billboard will rotate.
float | getOffset ()
| Returns the distance toward the camera (or the look_at_point) the billboard is moved towards, after rotating.
Vec3 const | getUpVector ()
| Returns the up vector in effect for this billboard.
bool | isOff ()
| Returns true if the BillboardEffect is an 'off' BillboardEffect, indicating that it does not enable billboarding.
## Static Public Member Functions
static TypeHandle | getClassType ()
static RenderEffect const | make (Vec3 const up_vector, bool eye_relative, bool axial_rotate, float offset, NodePath const look_at, Point3 const look_at_point)
| Constructs a new BillboardEffect object with the indicated properties.
static RenderEffect const | makeAxis ()
| A convenience function to make a typical axis-rotating billboard.
static RenderEffect const | makePointEye ()
| A convenience function to make a typical eye-relative point-rotating billboard.
static RenderEffect const | makePointWorld ()
| A convenience function to make a typical world-relative point-rotating billboard.

## Detailed Description

Indicates that geometry at this node should automatically rotate to face the camera, or any other arbitrary node.

## Member Function Documentation

bool getAxialRotate | ( |  | ) |

Returns true if this billboard rotates only around the axis of the up vector, or false if it rotates freely in three dimensions.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from RenderEffect.

bool getEyeRelative | ( |  | ) |

Returns true if this billboard interprets the up vector relative to the camera, or false if it is relative to the world.

NodePath const getLookAt | ( |  | ) |

Returns the node this billboard will rotate to look towards.

If this is empty, it means the billboard will rotate towards the current camera node, wherever that might be.

Point3 const getLookAtPoint | ( |  | ) |

Returns the point, relative to the look_at node, towards which the billboard will rotate.

Normally this is (0, 0, 0).

float getOffset | ( |  | ) |

Returns the distance toward the camera (or the look_at_point) the billboard is moved towards, after rotating.

This can be used to ensure the billboard is not obscured by nearby geometry.

Vec3 const getUpVector | ( |  | ) |

Returns the up vector in effect for this billboard.

bool isOff | ( |  | ) |

Returns true if the BillboardEffect is an 'off' BillboardEffect, indicating that it does not enable billboarding.

This kind of BillboardEffect isn't particularly useful and isn't normally created or stored in the graph; it might be implicitly discovered as the result of a NodePath.get_rel_state().

static RenderEffect const make | ( | Vec3 const | up_vector,
|  | bool | eye_relative,
|  | bool | axial_rotate,
|  | float | offset,
|  | NodePath const | look_at,
|  | Point3 const | look_at_point
| ) |  | `[static]`

Constructs a new BillboardEffect object with the indicated properties.

static RenderEffect const makeAxis | ( |  | ) | `[static]`

A convenience function to make a typical axis-rotating billboard.

static RenderEffect const makePointEye | ( |  | ) | `[static]`

A convenience function to make a typical eye-relative point-rotating billboard.

static RenderEffect const makePointWorld | ( |  | ) | `[static]`

A convenience function to make a typical world-relative point-rotating billboard.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties